Imports Microsoft.VisualBasic
Imports System
Imports System.Collections.Generic
Imports System.Linq
Imports System.Runtime.Serialization
Imports System.ServiceModel
Imports System.Text
Imports System.ServiceModel.Web
Imports System.ServiceModel.Syndication

Namespace MSDNMagazine
<ServiceContract> _
Public Interface IMSDNMagazineService
	<OperationContract, WebGet(UriTemplate:="/")> _
	Function GetAllIssues() As IssuesCollection
	<OperationContract, WebGet(UriTemplate := "/servicedoc")> _
	Function GetServiceDoc() As AtomPub10ServiceDocumentFormatter
	<OperationContract, WebGet(UriTemplate := "/feed?format={format}"), ServiceKnownType(GetType(Atom10FeedFormatter)), ServiceKnownType(GetType(Rss20FeedFormatter))> _
	Function GetIssuesFeed(ByVal format As String) As SyndicationFeedFormatter
	<OperationContract, WebGet(UriTemplate := "/{year}")> _
	Function GetIssuesByYear(ByVal year As String) As IssuesData
	'remainder of interface commented for clarity
	#Region "Commented for clarity"

	<OperationContract, WebGet(UriTemplate := "/{year}/{issue}")> _
	Function GetIssue(ByVal year As String, ByVal issue As String) As Articles
	<OperationContract, WebGet(UriTemplate := "/{year}/{issue}/{article}")> _
	Function GetArticle(ByVal year As String, ByVal issue As String, ByVal article As String) As Article
	<OperationContract, WebInvoke(UriTemplate := "/{year}/{issue}", Method := "POST")> _
	Function AddArticle(ByVal year As String, ByVal issue As String, ByVal article As Article) As Article

	#End Region    
End Interface
	<CollectionDataContract(Name:="msdnMagazine",Namespace:="",ItemName:="year")> _
	Public Class IssuesCollection
		Inherits List(Of String)
	End Class
	<DataContract(Name:="issuesByYear",Namespace:="")> _
	Public Class IssuesData
		<DataMember(Name:="year")> _
		Public Year As String
		<DataMember> _
		Public Issues As MonthInfo
	End Class
	<DataContract(Name := "issue", Namespace := "")> _
	Public Class IssueData
		<DataMember(Name := "year")> _
		Public Year As String
		<DataMember> _
		Public Issues As MonthInfo
	End Class
	<CollectionDataContract(Name := "articles", Namespace := "")> _
	Public Class Articles
		Inherits List(Of Article)
	End Class
	<DataContract(Namespace:="",Name:="article")> _
	Public Class Article
		<DataMember(Name:="id")> _
		Public Id As String
		<DataMember(Name := "author")> _
		Public Author As String
		<DataMember(Name := "title")> _
		Public Title As String
		<DataMember(Name := "content")> _
		Public Content As String
		<DataMember(Name := "year")> _
		Public Year As String
		<DataMember(Name := "issue")> _
		Public Issue As String
	End Class
	<CollectionDataContract(Name := "issues", Namespace := "",ItemName:="issue")> _
	Public Class MonthInfo
		Inherits List(Of String)
	End Class

End Namespace
